#include    <stdio.h>
#include    <string.h>

#include    "pokesound.h"
#include    "cli.h"

/* -------------------------------------------------------------- */
int init_cli(int k)
{
fprintf(stderr, ">>> %s ( %d )\n", __func__, k);

return 7;
}
/* -------------------------------------------------------------- */

typedef struct {
	char		*opcode;
	int		command;
	} Keyword;

Keyword keywords[] = {
	{	"message",	1		},
	{	"create",	2		},
	{	"export",	3		},
	{	"loadfile",	4		},
	{	"pokewave",	5		},
	{	"brotch",	6		},
	{	NULL,		0		}
	};

int lookup_keyword(char *kw)
{
Keyword		*kptr;

fprintf(stderr,">>> %s ( '%s' )\n", __func__, kw);

if (NULL == kw)		return -1;

kptr = keywords;
while (NULL != kptr->opcode) {
	if (! strcmp(kw, kptr->opcode)) {
		return kptr->command;
		}
	kptr++;
	}
return 0;
}
/* -------------------------------------------------------------- */

#define T_BUFF_CLI   200

int run_the_cli(FILE *fp)
{
char		line[T_BUFF_CLI+1];
char		copy[T_BUFF_CLI+1];
char		*cptr, *target, *params;

int		linenumber = 1;
int		len, com;

fprintf(stderr, ">>> %s ( %p )\n", __func__, fp);

while (NULL!=(cptr=fgets(line, T_BUFF_CLI, fp))) {

	len = strlen(line);
	// fprintf(stderr, "len=%d %02x\n", len, line[len-1]);
	if ('\n'==line[len-1]) line[len-1]='\0';

	strcpy(copy, line);
	fprintf(stderr, "%3d : %s\n", linenumber, copy);
	linenumber++;

	cptr = strtok(copy, " \t");
	if (NULL == cptr) {		/* empty line ? */
		continue;
		}
	if (';' == *cptr) {		/* this is a comment */
		continue;
		}

	fprintf(stderr, "    keyword [%s]\n", cptr);
	
	target = strtok(NULL, " \t");
	fprintf(stderr, "    target = %s\n", target);

	params = line + (target - copy);
	fprintf(stderr, "    params = %s\n", params);

	com = lookup_keyword(cptr);
	// fprintf(stderr, "    %s -> %d\n", cptr, com);
	switch (com) {
		case -1:	case 0:
			break;

		case 1:
			do_message(params);
			break;
		case 2:
			do_create_buff(params);
			symb_list("foo");
			break;
		case 3:
			do_export(params);
			break;
		case 4:
			do_load_file(params);
			break;

		default:
			fprintf(stderr, "    %d ???\n", com);
			break;
		}

	puts("");
	}

return 14;
}
/* -------------------------------------------------------------- */

/* -------------------------------------------------------------- */
